public class UE9Aufgabe8 {

	public static void main(String[] args) {
		int feldgroesse = feldgroesseErmitteln();
		boolean[][] feld = feldInitialisieren(feldgroesse);
		feldAusgeben(feld);

		while (!spielEnde(feld)) {
			LampenSpielzug zug = spielzugEinlesen(feldgroesse);
			spielzugAusfuehren(feld, zug);
			feldAusgeben(feld);
		}

	}

	static int feldgroesseErmitteln() {
		int feldgroesse = IO.readInt("Feldgroesse (2 < n < 10): ");
		while (feldgroesse < 3 || feldgroesse > 9) {
			feldgroesse = IO
					.readInt("Fehlerhafte Eingabe! Feldgroesse (2 < n < 10): ");
		}
		return feldgroesse;
	}

	static boolean[][] feldInitialisieren(int groesse) {
		boolean[][] feld = new boolean[groesse][groesse];
		for (int r = 0; r < groesse; r++) {
			for (int s = 0; s < groesse; s++) {
				feld[r][s] = false;
			}
		}
		return feld;
	}

	static void feldAusgeben(boolean[][] feld) {
		// Spaltennummerierung
		System.out.print(' ');
		for (int s = 0; s < feld[0].length; s++) {
			System.out.print("" + s);
		}
		System.out.println();

		// Feldinhalt ausgeben
		for (int r = 0; r < feld.length; r++) {
			System.out.print(r); // Nummerierung
			for (int s = 0; s < feld[r].length; s++) {
				if (feld[r][s]) {
					System.out.print('+'); // Lampe an
				} else {
					System.out.print('.'); // Lampe aus
				}
			}
			System.out.println();
		}
	}

	static boolean spielEnde(boolean[][] feld) {
		for (int r = 0; r < feld.length; r++) {
			for (int s = 0; s < feld[r].length; s++) {
				if (!feld[r][s]) {
					return false; // eine Lampe aus
				}
			}
		}
		return true; // alle Lampen an
	}

	static LampenSpielzug spielzugEinlesen(int groesse) {
		LampenSpielzug zug = new LampenSpielzug();
		zug.reihe = IO
				.readInt("Reihe der Lampe, die umgeschaltet werden soll (0 <= r < "
						+ groesse + "): ");
		while (zug.reihe < 0 || zug.reihe >= groesse) {
			IO.println("Fehlerhafte Eingabe!");
			zug.reihe = IO
					.readInt("Reihe der Lampe, die umgeschaltet werden soll (0 <= r < "
							+ groesse + "): ");
		}
		zug.spalte = IO
				.readInt("Spalte der Lampe, die umgeschaltet werden soll (0 <= r < "
						+ groesse + "): ");
		while (zug.spalte < 0 || zug.spalte >= groesse) {
			IO.println("Fehlerhafte Eingabe!");
			zug.spalte = IO
					.readInt("Spalte der Lampe, die umgeschaltet werden soll (0 <= r < "
							+ groesse + "): ");
		}
		return zug;
	}

	static void spielzugAusfuehren(boolean[][] feld, LampenSpielzug zug) {
		// betroffene Lampe umschalten
		feld[zug.reihe][zug.spalte] = !feld[zug.reihe][zug.spalte];

		// Nachbarlampen umschalten
		if (zug.reihe - 1 >= 0) {
			feld[zug.reihe - 1][zug.spalte] = !feld[zug.reihe - 1][zug.spalte];
		}
		if (zug.reihe + 1 < feld.length) {
			feld[zug.reihe + 1][zug.spalte] = !feld[zug.reihe + 1][zug.spalte];
		}
		if (zug.spalte - 1 >= 0) {
			feld[zug.reihe][zug.spalte - 1] = !feld[zug.reihe][zug.spalte - 1];
		}
		if (zug.spalte + 1 < feld[0].length) {
			feld[zug.reihe][zug.spalte + 1] = !feld[zug.reihe][zug.spalte + 1];
		}
	}

}

class LampenSpielzug {
	int reihe;
	int spalte;
}
